<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-view-query.inc.php 4346 2006-03-06 16:43:19Z andrew@m3.net $
*/

// Set define to prevent duplicate include
define ('LIBVIEWQUERY_INCLUDED', true);

/*-------------------------------------------------------*/
/* Build the query needed to fetch banners               */
/*-------------------------------------------------------*/

function phpAds_buildQuery ($part, $lastpart, $precondition)
{
	$conf = $GLOBALS['_MAX']['CONF'];

	// Setup basic query
	$select = "
        SELECT
	        b.bannerid AS bannerid,
	        b.campaignid AS campaignid,
	        az.priority AS priority,
	        b.contenttype AS contenttype,
	        b.storagetype AS type,
	        b.bannertext AS bannertext,
	        b.filename AS filename,
	        b.imageurl AS imageurl,
	        b.url AS url,
	        b.htmlcache AS htmlcache,
	        b.width AS width,
	        b.height AS height,
	        b.weight AS weight,
	        b.seq AS seq,
	        b.autohtml AS autohtml,
	        b.adserver AS adserver,
	        b.target AS target,
	        b.alt AS alt,
	        b.status AS status,
	        b.block AS block,
	        b.capping AS capping,
	        b.session_capping AS session_capping,
	        b.compiledlimitation AS compiledlimitation,
	        b.alt_filename AS alt_filename,
	        b.alt_contenttype AS alt_contenttype,
	        b.append AS append,
	        b.weight AS campaignweight
        FROM
            {$conf['table']['prefix']}{$conf['table']['banners']} AS b,
            {$conf['table']['prefix']}{$conf['table']['campaigns']} AS m

        WHERE
            b.active='t'
            AND m.active = 't'
            AND b.campaignid=m.campaignid
	";

	// Add preconditions to query
	if ($precondition != '')
		$select .= " $precondition ";


	// Other
	if ($part != '')
	{
		$conditions = '';

		$part_array = explode(',', $part);
		for ($k=0; $k < count($part_array); $k++)
		{
			$operator = 'OR';

			//	Test statements
			if($part_array[$k] != '' && $part_array[$k] != ' ')
			{
				// Banner dimensions
				if(preg_match('#^[0-9]+x[0-9]+$#', $part_array[$k]))
				{
					list($width, $height) = explode('x', $part_array[$k]);

					if ($operator == 'OR')
						$conditions .= "OR (b.width = $width AND b.height = $height) ";
					elseif ($operator == 'AND')
						$conditions .= "AND (b.width = $width AND b.height = $height) ";
					else
						$conditions .= "AND (b.width != $width OR b.height != $height) ";
				}

				// Banner Width
				elseif (substr($part_array[$k],0,6) == 'width:')
				{
					$part_array[$k] = substr($part_array[$k], 6);
					if($part_array[$k] != '' && $part_array[$k] != ' ')

					if ($operator == 'OR')
						$conditions .= "OR b.width = '".trim($part_array[$k])."' ";
					elseif ($operator == 'AND')
						$conditions .= "AND b.width = '".trim($part_array[$k])."' ";
					else
						$conditions .= "AND b.width != '".trim($part_array[$k])."' ";
				}

				// Banner ID
				elseif ((substr($part_array[$k], 0, 9) == 'bannerid:') || (preg_match('#^[0-9]+$#', $part_array[$k])))
				{
					if (substr($part_array[$k], 0, 9) == 'bannerid:')
						$part_array[$k] = substr($part_array[$k], 9);

					if ($part_array[$k] != '' && $part_array[$k] != ' ')
					{
						if ($operator == 'OR')
							$conditions .= "OR b.bannerid='".trim($part_array[$k])."' ";
						elseif ($operator == 'AND')
							$conditions .= "AND b.bannerid='".trim($part_array[$k])."' ";
						else
							$conditions .= "AND b.bannerid!='".trim($part_array[$k])."' ";
					}
				}

				// Campaign ID
				elseif (substr($part_array[$k], 0, 11) == 'campaignid:')
				{
					$part_array[$k] = substr($part_array[$k], 11);
					if ($part_array[$k] != '' && $part_array[$k] != ' ')
					{
						if ($operator == 'OR')
							$conditions .= "OR m.campaignid='".trim($part_array[$k])."' ";
						elseif ($operator == 'AND')
							$conditions .= "AND m.campaignid='".trim($part_array[$k])."' ";
						else
							$conditions .= "AND m.campaignid!='".trim($part_array[$k])."' ";
					}
				}

				// Format
				elseif (substr($part_array[$k], 0, 7) == 'format:')
				{
					$part_array[$k] = substr($part_array[$k], 7);
					if($part_array[$k] != '' && $part_array[$k] != ' ')
					{
						if ($operator == 'OR')
							$conditions .= "OR b.contenttype='".trim($part_array[$k])."' ";
						elseif ($operator == 'AND')
							$conditions .= "AND b.contenttype='".trim($part_array[$k])."' ";
						else
							$conditions .= "AND b.contenttype!='".trim($part_array[$k])."' ";
					}
				}

				// HTML
				elseif($part_array[$k] == 'html')
				{
					if ($operator == 'OR')
						$conditions .= "OR b.contenttype='html' ";
					elseif ($operator == 'AND')
						$conditions .= "AND b.contenttype='html' ";
					else
						$conditions .= "AND b.contenttype!='html' ";
				}
			}
		}

		// Strip first AND or OR from $conditions
		$conditions = strstr($conditions, ' ');

		// Add conditions to select
		if ($conditions != '') $select .= ' AND ('.$conditions.') ';
	}

	return ($select);
}


?>